import { ModelOperation } from '../utils/definitions';
type ACMConfig = {
    resources: string[];
    operations: ModelOperation[];
    name: string;
};
type SetRoleInput = {
    role: string;
    operations: Array<ModelOperation>;
    resource?: string;
    allowRoleOverwrite?: boolean;
};
export declare class AccessControlMatrix {
    private name;
    private roles;
    private operations;
    private resources;
    private matrix;
    constructor(config: ACMConfig);
    setRole(input: SetRoleInput): void;
    hasRole(role: string): boolean;
    getName(): string;
    getRoles(): Array<string>;
    getResources(): Readonly<Array<string>>;
    hasResource(resource: string): boolean;
    isAllowed(role: string, resource: string, operation: ModelOperation): boolean;
    resetAccessForResource(resource: string): void;
    getRolesPerOperation(operation: ModelOperation, fullAccess?: boolean): Array<string>;
    getAcmPerRole(): Map<string, unknown>;
    private validate;
    private getResourceOperationMatrix;
    private getOperationList;
}
export {};
//# sourceMappingURL=acm.d.ts.map