"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateAuthExpressionForSubscriptions = void 0;
const graphql_mapping_template_1 = require("graphql-mapping-template");
const common_1 = require("./common");
const generateAuthExpressionForSubscriptions = (providers, roles) => {
    const expressions = [];
    expressions.push((0, graphql_mapping_template_1.compoundExpression)((0, common_1.generateAuthRulesFromRoles)(roles, [], providers.hasIdentityPoolId, true)));
    expressions.push((0, graphql_mapping_template_1.set)((0, graphql_mapping_template_1.ref)('authResult'), (0, graphql_mapping_template_1.methodCall)((0, graphql_mapping_template_1.ref)('util.authRules.subscriptionAuth'), (0, graphql_mapping_template_1.ref)('authRules'))));
    expressions.push((0, common_1.validateAuthResult)());
    expressions.push((0, graphql_mapping_template_1.iff)((0, graphql_mapping_template_1.and)([(0, graphql_mapping_template_1.ref)('authResult'), (0, graphql_mapping_template_1.not)((0, graphql_mapping_template_1.methodCall)((0, graphql_mapping_template_1.ref)('util.isNullOrEmpty'), (0, graphql_mapping_template_1.ref)('authResult.authFilter')))]), (0, graphql_mapping_template_1.ifElse)((0, graphql_mapping_template_1.methodCall)((0, graphql_mapping_template_1.ref)('util.isNullOrEmpty'), (0, graphql_mapping_template_1.ref)('ctx.args.filter')), (0, graphql_mapping_template_1.set)((0, graphql_mapping_template_1.ref)('ctx.args.filter'), (0, graphql_mapping_template_1.ref)('authResult.authFilter')), (0, graphql_mapping_template_1.set)((0, graphql_mapping_template_1.ref)('ctx.args.filter'), (0, graphql_mapping_template_1.obj)({
        and: (0, graphql_mapping_template_1.list)([(0, graphql_mapping_template_1.ref)('authResult.authFilter'), (0, graphql_mapping_template_1.ref)('ctx.args.filter')]),
    })))));
    expressions.push(common_1.emptyPayload);
    return (0, graphql_mapping_template_1.printBlock)('Authorization rules')((0, common_1.generateIAMAccessCheck)(providers.genericIamAccessEnabled, (0, graphql_mapping_template_1.compoundExpression)(expressions)));
};
exports.generateAuthExpressionForSubscriptions = generateAuthExpressionForSubscriptions;
//# sourceMappingURL=subscription.js.map